Magellan Linux

Annotation of /tags/grubby-8_40_20170706/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2964 - (hide annotations) (download)
Wed Jun 29 14:45:50 2016 UTC (7 years, 9 months ago) by niro
Original Path: trunk/grubby/new-kernel-pkg
File size: 25116 byte(s)
Treat kernel and kernel-core as identical in terms of --make-default
1 niro 532 #!/bin/bash
2 niro 924 # $Id$
3 niro 532 #
4 niro 923 # new-kernel-pkg
5 niro 532 # Invoked upon installation or removal of a kernel package, the following
6     # tasks are/can be done here:
7     # creation/removal of initrd
8     # run of depmod/removal of depmod generated files
9     # addition/removal of kernel images from grub/lilo configuration (via grubby)
10     #
11 niro 923 # Copyright 2002-2008 Red Hat, Inc. All rights reserved.
12 niro 532 # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13     #
14 niro 923 # This program is free software; you can redistribute it and/or modify
15     # it under the terms of the GNU General Public License as published by
16     # the Free Software Foundation; either version 2 of the License, or
17     # (at your option) any later version.
18     #
19     # This program is distributed in the hope that it will be useful,
20     # but WITHOUT ANY WARRANTY; without even the implied warranty of
21     # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
22     # GNU General Public License for more details.
23     #
24     # You should have received a copy of the GNU General Public License
25     # along with this program. If not, see <http://www.gnu.org/licenses/>.
26     #
27 niro 532
28 niro 1778 read_os_release()
29     {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52     }
53    
54 niro 532 PATH=/sbin:/bin:$PATH
55    
56     lilo=/sbin/lilo
57    
58     # some defaults that are sane for most arches
59     kernelName=kernel
60    
61 niro 924 if [ -x ./grubby ]
62     then
63     grubby=./grubby
64 niro 532 else
65 niro 924 grubby=/sbin/grubby
66 niro 532 fi
67    
68 niro 925 [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69 niro 1691 [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70 niro 532
71 niro 1697 cfgGrub2=""
72     cfgGrub2Efi=""
73 niro 532 cfgGrub=""
74     cfgLilo=""
75 niro 1716 cfgExtlinux=""
76 niro 1691 cfguBoot=""
77 niro 532 runLilo=""
78     grubConfig=""
79 niro 1702 grub2Config=""
80     grub2EfiConfig=""
81 niro 1716 extlinuxConfig=""
82 niro 2961 ubootScript="/boot/boot.scr"
83 niro 532
84     ARCH=$(uname -m)
85    
86 niro 924 if [[ ${ARCH} = ia64 ]]
87     then
88     liloConfig=/boot/efi/EFI/redhat/elilo.conf
89     bootPrefix=/boot/efi/EFI/redhat
90     liloFlag=elilo
91     isx86=""
92     elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
93     then
94     liloConfig=/etc/yaboot.conf
95 niro 1803 grub2Config=/boot/grub/grub.cfg
96 niro 924 bootPrefix=/boot
97     lilo=/sbin/ybin
98     liloFlag=yaboot
99     runLilo="yes"
100     isx86=""
101     elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
102     then
103     liloConfig=/etc/silo.conf
104     bootPrefix=/boot
105     liloFlag=silo
106     lilo=/sbin/silo
107     isx86=""
108     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
109     then
110     liloConfig=/etc/zipl.conf
111     bootPrefix=/boot
112     liloFlag=zipl
113     lilo=/sbin/zipl
114     runLilo="yes"
115     isx86=""
116 niro 1848 elif [[ ${ARCH} =~ armv[5|7].*l ]]
117 niro 1691 then
118     liloConfig=""
119     bootPrefix=/boot
120 niro 2259 extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
121 niro 1847 ubootDir=${UBOOT_DIR:-"/boot"}
122 niro 1691 ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
123     ubootKList=${UBOOT_KLIST:-"klist.txt"}
124     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
125     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
126     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
127 niro 1937 ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
128 niro 1691 mounted=""
129     liloFlag=""
130     isx86=""
131 niro 532 else
132 niro 924 # this leaves i?86 and x86_64
133     liloConfig=/etc/lilo.conf
134     grubConfig=/boot/grub/grub.conf
135 niro 1697 grub2Config=/boot/grub/grub.cfg
136     grub2EfiConfig=/boot/grub/grub-efi.cfg
137 niro 1716 extlinuxConfig=/boot/extlinux/extlinux.conf
138 niro 924 bootPrefix=/boot
139     liloFlag=lilo
140     isx86="yes"
141 niro 532 fi
142    
143     mode=""
144     version=""
145     initrd=""
146 niro 1334 dracut=""
147     dracuthostonly=""
148 niro 532 initrdfile=""
149 niro 2685 devtreefile=""
150 niro 532 moddep=""
151     verbose=""
152     makedefault=""
153     package=""
154 niro 1706 mbkernel="${HYPERVISOR}"
155     mbargs="${HYPERVISOR_ARGS}"
156 niro 1334 adddracutargs=""
157     addplymouthinitrd=""
158 niro 2961 DEBUGARG="systemd.debug"
159 niro 532
160 niro 924 usage()
161     {
162 niro 1334 echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
163 niro 924 echo " [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
164 niro 1305 echo " [--kernel-args=<args>] [--remove-args=<args>]" >&2
165 niro 924 echo " [--banner=<banner>] [--multiboot=multiboot]" >&2
166 niro 1334 echo " [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
167     echo " [--add-plymouth-initrd]" >&2
168 niro 2685 echo " [--host-only] [--devtree=<devicetree.dtb>]" >&2
169 niro 924 echo " <--install | --remove | --update> <kernel-version>" >&2
170     echo " (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
171     exit 1
172 niro 532 }
173    
174 niro 2961 rungrubby()
175     {
176     if [[ $1 == --debug ]]
177     then
178     [[ ${MAKEDEBUG} != yes ]] && return 0
179     [[ -n ${verbose} ]] && echo "- First, making a debug entry."
180     declare -x debugtitle=" with debugging"
181     declare -x debugargs="${DEBUGARG}"
182     shift
183     else
184     [[ -n ${verbose} ] && echo "- Making a normal entry."
185     fi
186     $(eval $grubby $@)
187     export -n debugargs
188     export -n debugtitle
189     unset debugargs
190     unset debugtitle
191     }
192    
193     set_title()
194     {
195     if [[ -n ${banner} ]]
196     then
197     if [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
198     then
199     title=$(echo ${banner} | sed 's/ /_/g')
200     else
201     title="${banner} [ ${version} ]"
202     fi
203     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
204     then
205     title=$(echo ${version} | sed 's/ /_/g')
206     elif [ -f /etc/os-release ]
207     then
208     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
209     elif [ -f /etc/mageversion ]
210     then
211     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
212     else
213     title="Magellan Linux [ ${version} ]"
214     fi
215     }
216    
217 niro 924 install()
218     {
219     # XXX kernel should be able to be specified also (or work right on ia64)
220 niro 2241 if [ ! -f ${kernelImage} ]
221 niro 924 then
222     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
223     return
224     fi
225 niro 923
226 niro 924 INITRD=""
227     if [ -f ${initrdfile} ]
228     then
229     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
230     INITRD="--initrd ${initrdfile}"
231 niro 1334
232     if [[ -n ${addplymouthinitrd} ]]
233     then
234     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
235     fi
236 niro 924 fi
237 niro 532
238 niro 2685 DEVTREE=""
239 niro 2704 if [[ x${devtreefile} != x ]] && [ -f "${devtreefile}" ]
240 niro 2685 then
241     [[ -n ${verbose} ]] && echo "found ${devtreefile} and using it with grubby"
242     DEVTREE="--devtree ${devtreefile}"
243     fi
244    
245 niro 924 # FIXME: is this a good heuristic to find out if we're on iSeries?
246     if [ -d /proc/iSeries ]
247     then
248     [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
249     if [[ -z ${initrdfile} ]]
250     then
251     [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
252 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
253 niro 924 else
254 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
255 niro 924 /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
256     rm ${bootPrefix}/vmlinux.sm-${version}
257     fi
258     return
259 niro 532 fi
260    
261 niro 924 # get the root filesystem to use
262 niro 2238 rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab 2>/dev/null)
263 niro 2237 if [[ -z $rootdevice ]]
264     then
265     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
266     fi
267 niro 532
268 niro 924 if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
269     then
270     [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
271     cfgLilo=""
272     fi
273 niro 532
274 niro 2961 set_title
275 niro 2239
276 niro 924 if [[ -n ${cfgGrub} ]]
277     then
278     [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
279 niro 532
280 niro 2961 ARGS="--grub -c ${grubConfig} --add-kernel=${kernelImage} ${INITRD} \
281     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
282     ${mbargs:+--mbargs=\"${mbargs}\"} \
283     --title=\"${title}\${debugtitle}\" --copy-default \
284     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
285     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
286     rungrubby --debug ${ARGS}
287     rungrubby ${ARGS} ${makedefault}
288 niro 532 else
289 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
290 niro 532 fi
291 niro 1697 if [[ -n ${cfgGrub2} ]]
292     then
293     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
294 niro 532
295 niro 2961 ARGS="--grub2 -c ${grub2Config} --add-kernel=${kernelImage} ${INITRD} \
296     --copy-default --title \"${title}\${debugtitle}\" \
297     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
298     ${mbargs:+--mbargs=\"${mbargs}\"} \
299     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
300     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
301     rungrubby --debug ${ARGS}
302     rungrubby ${ARGS} ${makedefault}
303 niro 1697 else
304     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
305     fi
306     if [[ -n ${cfgGrub2Efi} ]]
307     then
308     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
309    
310 niro 2961 ARGS="--grub2 -c ${grub2EfiConfig} --efi \
311     --add-kernel=${kernelImage} ${DEVTREE} ${INITRD} \
312     --copy-default --title \"${title}\${debugtitle}\" \
313     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
314     ${mbargs:+--mbargs=\"${mbargs}\"} \
315     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
316     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
317     rungrubby --debug ${ARGS}
318     rungrubby ${ARGS} ${makedefault}
319 niro 1697 else
320     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
321     fi
322    
323 niro 924 if [[ -n ${cfgLilo} ]]
324     then
325     [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
326 niro 532
327 niro 2961 ARGS="--${liloFlag} --add-kernel=${kernelImage} ${INITRD} \
328     --copy-default --title \"${title}\${debugtitle}\" \
329     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
330     ${mbargs:+--mbargs=\"${mbargs}\"} \
331     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
332     --remove-kernel=\"TITLE=${version}\""
333     rungrubby --debug ${ARGS}
334     rungrubby ${ARGS} ${makedefault}
335 niro 532
336 niro 924 if [[ -n ${runLilo} ]]
337     then
338     [[ -n ${verbose} ]] && echo "running ${lilo}"
339 niro 1305 if [ ! -x ${lilo} ]
340 niro 924 then
341     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
342     else
343     ${lilo} > /dev/null
344     fi
345     fi
346     else
347     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
348 niro 532 fi
349 niro 1716
350     if [[ -n ${cfgExtlinux} ]]
351     then
352     [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
353    
354 niro 2961 ARGS="--extlinux -c ${extlinuxConfig} --add-kernel=${kernelImage} \
355     ${INITRD} --copy-default --title \"${title}\${debugtitle}\" \
356     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
357     ${mbargs:+--mbargs=\"${mbargs}\"} \
358     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
359     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
360     rungrubby --debug ${ARGS}
361     rungrubby ${ARGS} ${makedefault}
362 niro 1716 else
363     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
364     fi
365 niro 532 }
366    
367 niro 924 remove()
368     {
369     # FIXME: is this a good heuristic to find out if we're on iSeries?
370     if [ -d /proc/iSeries ]
371     then
372     [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
373 niro 2241 rm -f ${kernelImage}.img 2>/dev/null
374 niro 924 return
375     fi
376 niro 532
377 niro 924 if [[ -n ${cfgGrub} ]]
378     then
379     [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
380 niro 1710 ${grubby} --grub -c ${grubConfig} \
381 niro 2241 --remove-kernel=${kernelImage}
382 niro 924 else
383 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
384 niro 924 fi
385 niro 1697 if [[ -n ${cfgGrub2} ]]
386     then
387     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
388     ${grubby} --grub2 -c ${grub2Config} \
389 niro 2241 --remove-kernel=${kernelImage}
390 niro 1697 else
391     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
392     fi
393     if [[ -n ${cfgGrub2Efi} ]]
394     then
395     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
396 niro 2051 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
397 niro 2241 --remove-kernel=${kernelImage}
398 niro 1697 else
399     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
400     fi
401 niro 532
402 niro 924 if [[ -n ${cfgLilo} ]]
403     then
404     [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
405 niro 2241 ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
406 niro 532
407 niro 924 if [[ -n ${runLilo} ]]
408     then
409     [[ -n ${verbose} ]] && echo "running ${lilo}"
410     if [ ! -x ${lilo} ]
411     then
412     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
413     else
414     ${lilo} > /dev/null
415     fi
416     fi
417     else
418     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
419 niro 532 fi
420 niro 1691
421     if [[ -n ${cfguBoot} ]]
422     then
423     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
424    
425     if [ -f ${ubootDir}/${ubootKList} ]
426     then
427     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
428     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
429 niro 1847 sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
430 niro 1691 newversion=$(tail -n1 ${tmpKList})
431     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
432     then
433     if [[ ${curversion} != ${newversion} ]]
434     then
435     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
436     if [ $? -ne 0 ]
437     then
438     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
439     fi
440     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
441     if [ $? -ne 0 ]
442     then
443     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
444     fi
445     fi
446    
447     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
448     if [ -f ${ubootDir}/uImage-${version} ]
449     then
450     rm -f ${ubootDir}/uImage-${version}
451     else
452     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
453     fi
454    
455     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
456     if [ -f ${ubootDir}/uInitrd-${version} ]
457     then
458     rm -f ${ubootDir}/uInitrd-${version}
459     else
460     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
461     fi
462    
463     mv ${tmpKList} ${ubootDir}/${ubootKList}
464 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
465 niro 1691 else
466     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
467     [ -f ${tmpKList} ] && rm -f ${tmpKList}
468     fi
469     else
470 niro 1752 [[ -n ${verbose} ]] && echo "No previous kernel version. U-Boot images not removed!"
471 niro 1691 fi
472     else
473     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
474     fi
475 niro 1716
476     if [[ -n ${cfgExtlinux} ]]
477     then
478     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
479     ${grubby} --extlinux -c ${extlinuxConfig} \
480 niro 2241 --remove-kernel=${kernelImage}
481 niro 1716 else
482     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
483     fi
484 niro 532 }
485    
486 niro 924 update()
487     {
488 niro 2241 if [ ! -f ${kernelImage} ]
489 niro 1305 then
490     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
491     return
492     fi
493    
494 niro 2961 set_title
495    
496 niro 1305 INITRD=""
497     if [ -f ${initrdfile} ]
498     then
499     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
500     INITRD="--initrd ${initrdfile}"
501 niro 1334
502     if [[ -n ${addplymouthinitrd} ]]
503     then
504     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
505     fi
506 niro 1305 fi
507    
508 niro 924 if [[ -n ${cfgGrub} ]]
509     then
510     [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
511 niro 2961 ARGS="--grub -c ${grubConfig} --update-kernel=${kernelImage} ${INITRD} \
512     ${kernargs:+--args=\"${kernargs}\"} \
513     ${removeargs:+--remove-args=\"${removeargs}\"} \
514     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
515     --title=\"${title}\${debugtitle}\""
516     rungrubby --debug ${ARGS}
517     rungrubby ${ARGS}
518 niro 924 else
519     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
520     fi
521 niro 923
522 niro 1697 if [[ -n ${cfgGrub2} ]]
523     then
524     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
525 niro 2961 ARGS="--grub2 -c ${grub2Config} --update-kernel=${kernelImage} ${INITRD} \
526     ${kernargs:+--args=\"${kernargs}\"} \
527     ${removeargs:+--remove-args=\"${removeargs}\"} \
528     --title=\"${title}\${debugtitle}\""
529     rungrubby --debug ${ARGS}
530     rungrubby ${ARGS}
531 niro 1697 else
532     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
533     fi
534    
535     if [[ -n ${cfgGrub2Efi} ]]
536     then
537     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
538 niro 2961 ARGS="--grub2 -c ${grub2EfiConfig} --efi --update-kernel=${kernelImage} \
539     ${INITRD} ${kernargs:+--args=\"${kernargs}\"} \
540     ${removeargs:+--remove-args=\"${removeargs}\"} \
541     --title=\"${title}\${debugtitle}\""
542     rungrubby --debug ${ARGS}
543     rungrubby ${ARGS}
544 niro 1697 else
545     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
546     fi
547    
548 niro 924 if [[ -n ${cfgLilo} ]]
549     then
550     [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
551 niro 2961 ARGS="--${liloFlag} --update-kernel=${kernelImage} ${INITRD} \
552     ${kernargs:+--args=\"${kernargs}\"} \
553     ${removeargs:+--remove-args=\"${removeargs}\"} \
554     --title=\"${title}\${debugtitle}\""
555     rungrubby --debug ${ARGS}
556     rungrubby ${ARGS}
557 niro 923
558 niro 924 if [[ -n ${runLilo} ]]
559     then
560     [[ -n ${verbose} ]] && echo "running ${lilo}"
561     if [ ! -x ${lilo} ]
562     then
563     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
564     else
565     ${lilo} > /dev/null
566     fi
567     fi
568     else
569     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
570 niro 923 fi
571 niro 1691
572     if [[ -n ${cfguBoot} ]]
573     then
574     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
575    
576     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
577 niro 1752 mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
578     -e ${ubootAddress} -n ${version} \
579 niro 2241 -d ${kernelImage} ${ubootDir}/uImage-${version}
580 niro 1691
581     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
582     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
583     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
584    
585     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
586     then
587     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
588     if [ $? -ne 0 ]
589     then
590     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
591     fi
592     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
593     if [ $? -ne 0 ]
594     then
595     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
596     fi
597     echo ${version} >> ${ubootDir}/${ubootKList}
598 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
599 niro 1691 else
600     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
601     fi
602     else
603     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
604     fi
605 niro 1716
606     if [[ -n ${cfgExtlinux} ]]
607     then
608     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
609 niro 2961 ARGS="--extlinux -c ${extlinuxConfig} --update-kernel=${kernelImage} \
610     ${INITRD} ${kernargs:+--args=\"${kernargs}\"} \
611     ${removeargs:+--remove-args=\"${removeargs}\"} \
612     --title=\"${title}\${debugtitle}\""
613     rungrubby --debug ${ARGS}
614     rungrubby ${ARGS}
615 niro 1716 else
616     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
617     fi
618 niro 923 }
619    
620 niro 1756 makeinitrd()
621 niro 924 {
622 niro 1334 if [[ -n ${dracut} ]]
623     then
624 niro 1728 tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
625 niro 1334 else
626 niro 1749 tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
627 niro 1334 fi
628 niro 924 [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
629 niro 1334 ${tool}
630 niro 924 rc=$?
631     if [ ${rc} != 0 ]
632     then
633     echo "mkinitrd failed" >&2
634     exit 1
635     fi
636 niro 532 }
637    
638 niro 924 rminitrd()
639     {
640     [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
641     [ -f ${initrdfile} ] && rm -f ${initrdfile}
642 niro 532 }
643    
644 niro 924 doDepmod()
645     {
646     [[ -n ${verbose} ]] && echo "running depmod for ${version}"
647     depmod -ae -F /boot/System.map-${version} ${version}
648 niro 532 }
649    
650 niro 924 doRmmoddep()
651     {
652     [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
653 niro 2242 if [ -d /lib/modules/${version} ]
654     then
655     rm -f /lib/modules/${version}/modules.*.bin \
656 niro 2244 /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
657 niro 2242 fi
658 niro 532 }
659    
660    
661 niro 924 while [ $# -gt 0 ]
662     do
663     case $1 in
664     --mkinitrd)
665     initrd="make"
666     ;;
667 niro 532
668 niro 924 --rminitrd)
669     initrd="remove"
670     ;;
671 niro 532
672 niro 2685 --devtree*)
673     if [[ $1 == --devtree\=* ]]
674     then
675     devtreefile="${1#--devtreefile=}"
676     else
677     devtreefile="$2"
678     shift
679     fi
680     ;;
681    
682 niro 1334 --dracut)
683     dracut=--dracut
684     ;;
685    
686     --host-only)
687     dracuthostonly=-H
688     ;;
689    
690 niro 924 --initrdfile*)
691 niro 2240 if [[ $1 == --initrdfile\=* ]]
692 niro 924 then
693 niro 2240 initrdfile=${1#--initrdfile=}
694 niro 924 else
695     initrdfile=$2
696     shift
697     fi
698     ;;
699 niro 532
700 niro 924 --kernel-args*)
701 niro 2240 if [[ $1 == --kernel-args\=* ]]
702 niro 924 then
703 niro 2240 kernargs=${1#--kernel-args=}
704 niro 924 else
705     kernargs=$2
706     shift
707     fi
708     ;;
709 niro 532
710 niro 924 --remove-args*)
711 niro 2240 if [[ $1 == --remove-args\=* ]]
712 niro 924 then
713 niro 2240 removeargs=${1#--remove-args=}
714 niro 924 else
715     removeargs=$2
716     shift
717     fi
718     ;;
719 niro 923
720 niro 924 --banner*)
721 niro 2240 if [[ $1 == --banner\=* ]]
722 niro 924 then
723 niro 2240 banner=${1#--banner=}
724 niro 924 else
725     banner=$2
726     shift
727     fi
728     ;;
729 niro 532
730 niro 924 --multiboot*)
731 niro 2240 if [[ $1 == --multiboot\=* ]]
732 niro 924 then
733 niro 2240 mbkernel=${1#--multiboot=}
734 niro 924 else
735     # can't really support having an optional second arg here
736     # sorry!
737     mbkernel="/boot/xen.gz"
738     fi
739     ;;
740 niro 532
741 niro 924 --mbargs*)
742 niro 2240 if [[ $1 == --mbargs\=* ]]
743 niro 924 then
744 niro 2240 mbargs=${1#--mbargs=}
745 niro 924 else
746     mbargs="$2"
747     shift
748     fi
749     ;;
750 niro 532
751 niro 924 --depmod)
752     moddep="make"
753     ;;
754 niro 532
755 niro 924 --rmmoddep)
756     moddep="remove"
757     ;;
758 niro 532
759 niro 924 --make-default)
760     makedefault="--make-default"
761     ;;
762 niro 532
763 niro 2240 --package*)
764     if [[ $1 == --package\=* ]]
765 niro 924 then
766 niro 2240 package=${1#--package=}
767 niro 924 else
768     package=$2
769     shift
770     fi
771     ;;
772 niro 532
773 niro 1334 --add-dracut-args)
774     adddracutargs=--add-dracut-args
775     ;;
776    
777     --add-plymouth-initrd)
778     addplymouthinitrd=--add-plymouth-initrd
779     ;;
780    
781 niro 2241 --kernel-image*)
782     if [[ $1 == --kernel-image\=* ]]
783     then
784     kernelImage=${1#--kernel-image=}
785     else
786     kernelImage="$2"
787     shift
788     fi
789     if ! [[ -f ${kernelImage} ]]
790     then
791     echo "Can't find kernel image '${kernelImage}'" >&2
792     usage
793     exit 1
794     fi
795     ;;
796    
797 niro 924 -v)
798     verbose=-v
799     ;;
800 niro 532
801 niro 924 *)
802     if [[ -z ${mode} ]]
803     then
804     mode=$1
805     elif [[ -z ${version} ]]
806     then
807     version=$1
808     else
809     usage
810     fi
811     ;;
812     esac
813 niro 532
814 niro 924 shift
815 niro 532 done
816    
817     # make sure the mode is valid
818 niro 924 if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
819     then
820     usage
821 niro 532 fi
822    
823 niro 924 if [[ -z ${version} ]]
824     then
825     usage
826 niro 532 fi
827    
828 niro 924 if [ "${mode}" != "--install" -a "${makedefault}" ]
829     then
830     usage
831 niro 532 fi
832    
833 niro 924 kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
834 niro 532
835 niro 1305 # kernel image for 2.4 is kernel
836 niro 924 if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
837     then
838     if [[ ${kernelmajor} = 2.4 ]]
839     then
840     kernelName=kernel
841     fi
842 niro 532 fi
843    
844 niro 2241 [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
845    
846 niro 532 # set the initrd file based on arch; ia64 is the only currently known oddball
847 niro 924 if [[ -z ${initrdfile} ]]
848     then
849     INITRD_NAME_PREFIX="initrd"
850 niro 1334 if [[ -n ${dracut} ]]
851     then
852     INITRD_NAME_PREFIX="initramfs"
853     fi
854 niro 923
855 niro 924 if [[ $(uname -m) = ia64 ]]
856     then
857     initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
858     else
859     initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
860     fi
861 niro 532 fi
862 niro 924 [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
863 niro 532
864 niro 1334 # add dracut i18n, keyboard and plymouth kernel args if requested
865     if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
866     then
867 niro 2059 if [ -r /etc/vconsole.conf ]
868     then
869     . /etc/vconsole.conf
870 niro 1334
871 niro 2059 for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
872     do
873     val=$(eval echo \$$i)
874     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
875     done
876     else
877     if [ -r /etc/conf.d/consolefont ]
878     then
879     . /etc/conf.d/consolefont
880    
881     if [[ -n ${CONSOLEFONT} ]]
882     then
883     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
884     fi
885     fi
886    
887     if [ -r /etc/conf.d/keymap ]
888     then
889     . /etc/conf.d/keymap
890    
891     if [[ -n ${KEYMAP} ]]
892     then
893     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
894     fi
895     fi
896 niro 1334 fi
897    
898 niro 2059 if [ -r /etc/locale.conf ]
899 niro 1334 then
900 niro 2059 . /etc/locale.conf
901    
902     if [[ -n ${LANG} ]]
903     then
904     kernargs="${kernargs} LANG=${LANG}"
905     fi
906 niro 1334 fi
907     fi
908    
909 niro 532 # set this as the default if we have the package and it matches
910 niro 2964 if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] && [[ -n ${DEFAULTKERNEL} ]]
911 niro 924 then
912 niro 2964 if [[ ${package} = ${DEFAULTKERNEL} ]] || [[ ${package}-core = ${DEFAULTKERNEL} ]]
913     then
914     makedefault="--make-default"
915     [[ -n ${verbose} ]] && echo "making it the default based on config"
916     fi
917 niro 532 fi
918    
919 niro 924 if [[ ${moddep} = make ]]
920     then
921     doDepmod
922     elif [[ ${moddep} = remove ]]
923     then
924     doRmmoddep
925 niro 532 fi
926    
927 niro 924 if [[ ${initrd} = make ]]
928     then
929 niro 1756 makeinitrd
930 niro 924 elif [[ ${initrd} = remove ]]
931     then
932     rminitrd
933 niro 532 fi
934    
935 niro 924 if [ ! -x ${grubby} ]
936     then
937     [[ -n ${verbose} ]] && echo "${grubby} does not exist"
938     exit 0
939 niro 532 fi
940    
941 niro 924 [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
942 niro 1697 [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
943     [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
944 niro 924 [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
945 niro 1716 [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
946 niro 532
947 niro 1752 # if we have a U-Boot directory, but no boot script, check if the directory
948     # is mounted. If not, mount it, and then check if a boot script exists.
949 niro 1691 if [[ -n ${ubootDir} ]]
950     then
951 niro 1752 if [ -f ${ubootScript} ]
952 niro 1691 then
953 niro 1752 cfguBoot=1
954     else
955     mountEntry=$(mount | grep ${ubootDir})
956     if [[ -z ${mountEntry} ]]
957     then
958     mount ${ubootDevice} ${ubootDir}
959     mounted=1
960     fi
961     [ -f ${ubootScript} ] && cfguBoot=1
962 niro 1691 fi
963     fi
964    
965 niro 1937 # if we're using U-Boot, check if the default load address should change
966     if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
967     then
968     [[ ${version} =~ .([^.]*)$ ]]
969     platform=${BASH_REMATCH[1]}
970     # A few platforms use an alternate kernel load address
971     if [[ ${platform} = omap ]]
972     then
973     ubootAddress=0x80008000
974     elif [[ ${platform} = imx ]]
975     then
976     ubootAddress=0x90008000
977     fi
978     fi
979    
980 niro 532 # if we have a lilo config on an x86 box, see if the default boot loader
981     # is lilo to determine if it should be run
982 niro 924 if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
983     then
984     runLilo=$(${grubby} --bootloader-probe | grep lilo)
985 niro 532 fi
986    
987 niro 924 if [[ ${mode} = --install ]]
988     then
989     install
990     elif [[ ${mode} = --remove ]]
991     then
992     remove
993     elif [[ ${mode} = --update ]]
994     then
995     update
996 niro 532 fi
997    
998 niro 1752 # if we mounted the U-Boot directory, unmount it.
999     [[ -n ${mounted} ]] && umount ${ubootDir}
1000    
1001 niro 532 exit 0

Properties

Name Value
svn:executable *